apiVersion: v1
kind: ConfigMap
metadata:
  name: logstash
  namespace: elastic
data:
  logstash.yaml: |
    http.host: "0.0.0.0"

    xpack.monitoring.elasticsearch.hosts: ["http://elasticsearch:9200"]
    xpack.monitoring.enabled: true

  settings-mappings.json: |
    {
        "dynamic": "strict",

        "_source": {
            "enable": "false"
        },

        "mappings": {
            "properties": {
                "name": {
                    "type": "text",
                    "analyzer": "english"
                },
                "id": {
                    "type": "integer",
                    "index": "not_analyzed",
                    "store": "true"
                },
                "label": {
                    "type": "nested",
                    "properties": {
                        "level": {
                            "type": "text"
                        },
                        "categories": {
                            "type": "text"
                        }
                    }
                },
                "text": {
                    "type": "text",
                    "analyzer": "english"
                },
                "author": {
                    "type": "text"
                }
            }
        }
    }
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: logstash
  namespace: elastic
spec:
  replicas: 1
  selector:
    matchLabels:
      app: search
  template:
    metadata:
      labels:
        app: search
        component: logstash
    spec:
      containers:
        - name: logstash
          image: docker.elastic.co/logstash/logstash:8.5.3
          imagePullPolicy: Always
          ports:
            - containerPort: 5959
          volumeMounts:
            - mountPath: /usr/share/logstash/config/logstash.yaml
              name: logstash-config
              subPath: logstash.yaml
            - mountPath: /usr/share/elasticsearch/settings-mappings.json
              name: logstash-config
              subPath: settings-mappings.json
      volumes:
        - name: logstash-config
          configMap:
            name: logstash
            items:
                - key: logstash.yaml
                  path: logstash.yaml
                - key: settings-mappings.json
                  path: settings-mappings.json
---
apiVersion: v1
kind: Service
metadata:
  name: logstash
  namespace: elastic
  labels:
    app: search
    component: logstash
spec:
  type: ClusterIP
  ports:
    - port: 5959
      targetPort: 5959
  selector:
    component: logstash
